function [V, lam] = Lan(A, nev, msteps,orient)
%% function [V, lan] = Lan(A, nev, msteps) 
%% -------------------- computes very approximate eigenvectors
%% JUNK 
%% via lanczos
 [m, n] = size(A);
  v  = randn(m,1);
  t  = norm(v,2);
  v  =  v/t; 
  beta = 0; 
  V = [v]; 
  vold = v;
  orthTol = 1.e-08;
  wn = 0.0 ;
%%------------------------------
 for k=1:msteps
    w = A*v; 
    w = w - beta*vold ; 
    alpha = w'*v; 
    wn = wn + alpha*alpha;
    T(k,k) = alpha; 
    w = w - alpha*v;
    w = w - V* (V'*w);
    beta = w'*w;
    if (beta*k < orthTol*wn) 
        break
    end
    wn   = wn+2.0*beta;
    beta = sqrt(beta) ;
    vold = v; 
    v = w/ beta;
    V(:,k+1) = v;
    T(k,k+1) = beta; 
    T(k+1,k) = beta; 
 end
%%------------------------------------------------------------
 [U,lam] = eig(T(1:k,1:k));
 [lam, indx] = sort(diag(lam),orient);
 V = V(:,1:k)*U(:,indx(1:nev));
%%------------------------------------------------------------
%% wo = sum(exp(V),2);
